 addon/doxywizard/configdoc.h                   |    4 +
 addon/doxywizard/doxywizard.cpp                |  189 +-
 addon/doxywizard/doxywizard.pro.in             |    3 +
 addon/doxywizard/doxywizard_ja_JP.ts           | 3288 ++++++++++++++++++++++++
 addon/doxywizard/expert.cpp                    |  175 +-
 addon/doxywizard/for_lupdate_doxywizard.pro.in |    5 +
 addon/doxywizard/wizard.cpp                    |    2 +-
 configure                                      |    2 +-
 src/config.xml                                 |   19 +-
 src/configgen.py                               |   57 +
 10 files changed, 3615 insertions(+), 129 deletions(-)

diff --git a/addon/doxywizard/configdoc.h b/addon/doxywizard/configdoc.h
index 97ed6c3..cb849f6 100644
--- a/addon/doxywizard/configdoc.h
+++ b/addon/doxywizard/configdoc.h
@@ -1,8 +1,12 @@
 #ifndef CONFIGDOC_H
 #define CONFIGDOC_H
 
+#include <qmap.h>
+#include <qstring.h>
+
 class DocIntf;
 
 void addConfigDocs(DocIntf *doc);
+void addConfigDocs(QMap<QString, QString>* map);
 
 #endif
diff --git a/addon/doxywizard/doxywizard.cpp b/addon/doxywizard/doxywizard.cpp
index ce764e0..0b48979 100644
--- a/addon/doxywizard/doxywizard.cpp
+++ b/addon/doxywizard/doxywizard.cpp
@@ -21,29 +21,29 @@ MainWindow &MainWindow::instance()
 MainWindow::MainWindow()
   : m_settings(QString::fromAscii("Doxygen.org"), QString::fromAscii("Doxywizard"))
 {
-  QMenu *file = menuBar()->addMenu(tr("File"));
-  file->addAction(tr("Open..."), 
+  QMenu *file = menuBar()->addMenu(tr("&File"));
+  file->addAction(tr("&Open..."), 
                   this, SLOT(openConfig()), Qt::CTRL+Qt::Key_O);
-  m_recentMenu = file->addMenu(tr("Open recent"));
-  file->addAction(tr("Save"), 
+  m_recentMenu = file->addMenu(tr("Open &recent"));
+  file->addAction(tr("&Save"), 
                   this, SLOT(saveConfig()), Qt::CTRL+Qt::Key_S);
-  file->addAction(tr("Save as..."), 
+  file->addAction(tr("Save &as..."), 
                   this, SLOT(saveConfigAs()), Qt::SHIFT+Qt::CTRL+Qt::Key_S);
-  file->addAction(tr("Quit"),  
+  file->addAction(tr("&Quit"),  
                   this, SLOT(quit()), Qt::CTRL+Qt::Key_Q);
 
-  QMenu *settings = menuBar()->addMenu(tr("Settings"));
-  settings->addAction(tr("Reset to factory defaults"),
+  QMenu *settings = menuBar()->addMenu(tr("&Settings"));
+  settings->addAction(tr("&Reset to factory defaults"),
                   this,SLOT(resetToDefaults()));
-  settings->addAction(tr("Use current settings at startup"),
+  settings->addAction(tr("&Use current settings at startup"),
                   this,SLOT(makeDefaults()));
-  settings->addAction(tr("Clear recent list"),
+  settings->addAction(tr("&Clear recent list"),
                   this,SLOT(clearRecent()));
 
-  QMenu *help = menuBar()->addMenu(tr("Help"));
-  help->addAction(tr("Online manual"), 
+  QMenu *help = menuBar()->addMenu(tr("&Help"));
+  help->addAction(tr("&Online manual"), 
                   this, SLOT(manual()), Qt::Key_F1);
-  help->addAction(tr("About"), 
+  help->addAction(tr("&About"), 
                   this, SLOT(about()) );
 
   m_expert = new Expert;
@@ -244,8 +244,7 @@ void MainWindow::saveConfig(const QString &fileName)
   {
     QMessageBox::warning(this,
         tr("Error saving"),
-        tr("Error: cannot open the file ")+fileName+tr(" for writing!\n")+
-        tr("Reason given: ")+f.error());
+        tr("Error: cannot open the file %1 for writing.\nReason given: %2").arg(fileName).arg(f.error()));
     return;
   }
   QTextStream t(&f);
@@ -426,7 +425,7 @@ void MainWindow::runDoxygen()
       }
       else 
       {
-        qDebug() << tr("Can't find the doxygen command, make sure it's in your $$PATH");
+        qDebug() << tr("Can't find the doxygen command, make sure it's in your $$PATH.");
         doxygenPath = QString::fromAscii("");
       }
     }
@@ -554,7 +553,7 @@ void MainWindow::saveLog()
     else
     {
       QMessageBox::warning(0,tr("Warning"),
-          tr("Cannot open file ")+fn+tr(" for writing. Nothing saved!"),tr("ok"));
+          tr("Cannot open file %1 for writing. Nothing saved.").arg(fn),tr("ok"));
     }
   }
 }
@@ -625,19 +624,157 @@ bool MainWindow::discardUnsavedChanges(bool saveOption)
 
 //-----------------------------------------------------------------------
 
-int main(int argc,char **argv)
+struct ArgumentDecoder
 {
-  QApplication a(argc,argv);
-  MainWindow &main = MainWindow::instance();
-  if (argc==2 && argv[1][0]!='-') // name of config file as an argument
+  public:
+  struct ArgToFunc
+  {
+    public:
+    ArgToFunc() : m_func( NULL ) { }
+    ArgToFunc( const char *const optstr, void (ArgumentDecoder::*func)( QString ) )
+      : m_opt( QString::fromAscii( optstr ) ), m_func( func ), m_called( false )
+    {
+    }
+    bool valid() const { return m_opt.length() || m_func; }
+    bool checkMatch( const QString& arg, ArgumentDecoder& decoder )
+    {
+      if ( arg.indexOf( m_opt ) != 0 )
+      {
+        return false;
+      }
+      if ( m_called )
+      {
+        qDebug() << m_opt
+          + QString::fromAscii( " called twice: " ) + arg
+          + QString::fromAscii( "\n" );
+      }
+      m_called = true;
+      (decoder.*m_func)( arg.mid( m_opt.length() ) );
+      return true;
+    }
+
+    QString m_opt;
+    void (ArgumentDecoder::*m_func)( QString );
+    bool m_called;
+  };
+  
+  ArgumentDecoder( const QApplication& app, QTranslator* translator )
+     : m_app( app ), m_translator( translator )
+  {
+  }
+
+  void decode()
+  {
+    QStringList args = m_app.arguments();
+    m_locale = QLocale::system().name();
+    m_locale_overwritten = false;
+    m_localeFileDir = m_app.applicationDirPath();
+    
+    ArgToFunc optlist[] = 
+    {
+      // Longer named option should be first.
+      ArgToFunc( "--help", &ArgumentDecoder::processHelp),
+      ArgToFunc( "--ld:", &ArgumentDecoder::processLocaleFileDir ),
+      ArgToFunc( "--l:", &ArgumentDecoder::processLocale ),
+      ArgToFunc( "-h", &ArgumentDecoder::processHelp),
+      ArgToFunc( "-?", &ArgumentDecoder::processHelp),
+      ArgToFunc( "", &ArgumentDecoder::processConfigFile ),
+      ArgToFunc()
+    };
+    
+    QStringList::ConstIterator it = args.begin();
+    for ( ++it ; it != args.end() ; ++it )
+    {
+      for ( int i = 0; optlist[ i ].valid(); ++i )
+      {
+        if ( optlist[ i ].checkMatch( *it, *this ) )
+        {
+          break;
+        }
+      }
+    }
+    
+    if ( m_locale.length() )
+    {
+      QTextCodec::setCodecForTr( QTextCodec::codecForName( "utf8" ) );
+      QString l18nFileName = QString::fromAscii( "doxywizard_" ) + m_locale;
+      bool succeeded = m_translator->load( l18nFileName, m_localeFileDir );
+      if ( !succeeded && m_locale_overwritten )
+      {
+        QMessageBox::warning(
+          NULL,
+          QString::fromAscii( "Localization error" ),
+          l18nFileName + QString::fromAscii( ".qm or valid localization file not found." )
+        );
+      }
+      m_app.installTranslator( m_translator );
+    }
+  }
+  
+  void processLocale( QString remain )
+  {
+    m_locale = remain;
+    m_locale_overwritten = true;
+  }
+  
+  void processConfigFile( QString remain )
+  {
+    if ( remain.indexOf( L'-' ) == 0 )
+    {
+      QMessageBox::warning(
+        NULL,
+        QString::fromAscii( "Doxywizard Error" ),
+        QString::fromAscii( "Unknown command/option: " )
+          + remain
+          + QString::fromAscii( "\n" )
+      );
+      processHelp( remain );
+    }
+    m_configFile = remain;
+    MainWindow &main = MainWindow::instance();
+    main.loadConfigFromFile( m_configFile );
+  }
+  
+  void processLocaleFileDir( QString remain )
   {
-    main.loadConfigFromFile(QString::fromLocal8Bit(argv[1]));
+    m_localeFileDir = remain;
   }
-  else if (argc>1)
+  
+  void processHelp( QString )
   {
-    printf("Usage: %s [config file]\n",argv[0]);
-    exit(1);
+    QMessageBox::information(
+      NULL,
+      QString::fromAscii( "Doxywizard help" ),
+      QString::fromAscii(
+        "Usage: doxywizard [--l:<locale_id>]"
+        " [--ld:localization_file_dir] [config_doxyfile]\n\n"
+        "<locale_id> is string like ja_JP, or empty not to translate.\n"
+        "The default value is the string QLocale::system().name() returns.\n"
+        "doxywizard will try to load translation file 'doxywizard_<locale_id>.qm'.\n"
+        "The default settiong of your environment is '%1',\n"
+        "to load 'doxywizard_%1.qm'.\n"
+        ).arg(QLocale::system().name())
+      );
+    exit( 1 );
   }
+  
+  const QApplication& m_app;
+  QTranslator* m_translator;
+  bool m_locale_overwritten;
+  QString m_locale;
+  QString m_localeFileDir;
+  QString m_configFile;
+};
+
+//-----------------------------------------------------------------------
+
+int main(int argc,char **argv)
+{
+  QApplication app(argc,argv);
+  QTranslator translator; // should alive as long as app.
+  ArgumentDecoder argDecorder( app, &translator );
+  argDecorder.decode();
+  MainWindow &main = MainWindow::instance();
   main.show();
-  return a.exec();
+  return app.exec();
 }
diff --git a/addon/doxywizard/doxywizard.pro.in b/addon/doxywizard/doxywizard.pro.in
index 01832df..307986f 100644
--- a/addon/doxywizard/doxywizard.pro.in
+++ b/addon/doxywizard/doxywizard.pro.in
@@ -27,6 +27,9 @@ RESOURCES   += doxywizard.qrc
 INCBUFSIZE=$(PYTHON)  ../../src/increasebuffer.py
 win32:RC_FILE += doxywizard.rc
 
+TRANSLATIONS = doxywizard_ja_JP.ts
+CODECFORTR = UTF-8
+
 config.target = config_doxyw.cpp
 config.commands = $(LEX) -P$*YY -t $*.l | $(INCBUFSIZE) >$*.cpp
 config.depends = config_doxyw.l  ../../src/increasebuffer.py
diff --git a/addon/doxywizard/expert.cpp b/addon/doxywizard/expert.cpp
index 4c988c9..c735707 100644
--- a/addon/doxywizard/expert.cpp
+++ b/addon/doxywizard/expert.cpp
@@ -1,10 +1,10 @@
 #include <QtGui>
 #include <QtXml>
+#include <qmap.h>
 #include "expert.h"
 #include "inputbool.h"
 #include "inputstring.h"
 #include "inputint.h"
-#include "inputstring.h"
 #include "inputstrlist.h"
 #include "config.h"
 #include "version.h"
@@ -27,6 +27,8 @@ static QString convertToComment(const QString &s)
   }
 }
 
+static QMap<QString, QString> translatedTemplateDocs;
+
 void Expert::setHeader(const char *header)
 {
   m_header = SA(header);
@@ -64,6 +66,9 @@ Expert::Expert()
       exit(1);
     }
   }
+
+  addConfigDocs(&translatedTemplateDocs);
+
   m_rootElement = configXml.documentElement();
 
   createTopics(m_rootElement);
@@ -121,7 +126,7 @@ void Expert::createTopics(const QDomElement &rootElem)
     }
     childElem = childElem.nextSiblingElement();
   }
-  m_treeWidget->setHeaderLabels(QStringList() << SA("Topics"));
+  m_treeWidget->setHeaderLabels(QStringList() << tr("Topics"));
   m_treeWidget->insertTopLevelItems(0,items);
   connect(m_treeWidget,
           SIGNAL(currentItemChanged(QTreeWidgetItem *,QTreeWidgetItem *)),
@@ -133,28 +138,13 @@ static QString getDocsForNode(const QDomElement &child)
 {
   QString type = child.attribute(SA("type"));
   QString docs = SA("");
-  // read documentation text
-  QDomElement docsVal = child.firstChildElement();
-  while (!docsVal.isNull())
-  {
-    if (docsVal.tagName()==SA("docs") &&
-        docsVal.attribute(SA("doxywizard")) != SA("0"))
-    {
-      for (QDomNode n = docsVal.firstChild(); !n.isNull(); n = n.nextSibling())
-      {
-        QDomText t = n.toText();
-        if (!t.isNull()) docs+=t.data();
-      }
-      docs += SA("<br/>");
-    }
-    docsVal = docsVal.nextSiblingElement();
-  }
+  QDomElement docsVal;
 
   // for an enum we list the values
   if (type==SA("enum"))
   {
     docs += SA("<br/>");
-    docs += SA("Possible values are: ");
+    QString visList;
     int numValues=0;
     docsVal = child.firstChildElement();
     while (!docsVal.isNull())
@@ -172,55 +162,53 @@ static QString getDocsForNode(const QDomElement &child)
       if (docsVal.tagName()==SA("value"))
       {
         i++;
-        docs += SA("<code>") + docsVal.attribute(SA("name")) + SA("</code>");
+        visList += SA("<code>") + docsVal.attribute(SA("name")) + SA("</code>");
         QString desc = docsVal.attribute(SA("desc"));
         if (!desc.isEmpty())
         {
-          docs+= SA(" ")+desc;
+          visList+=Expert::tr(" %1", "for possible value list").arg(desc);
         }
         if (i==numValues-1)
         {
-          docs+=SA(" and ");
+          visList+=Expert::tr(" and ", "for possible value list");
         }
         else if (i==numValues)
         {
-          docs+=SA(".");
+          visList+=Expert::tr(".", "for possible value list");
         }
         else
         {
-          docs+=SA(", ");
+          visList+=Expert::tr(", ", "for possible value list");
         }
       }
       docsVal = docsVal.nextSiblingElement();
     }
+    docs+=Expert::tr("Possible values are: %1").arg(visList);
     docs+=SA("<br/>");
     docs+=SA("<br/>");
-    docs+=SA(" The default value is: <code>")+
-          child.attribute(SA("defval"))+
-          SA("</code>.");
-    docs+= SA("<br/>");
+    docs+=Expert::tr(" The default value is: <code>%1</code>.").arg(child.attribute(SA("defval")));
+    docs+=SA("<br/>");
   }
   else if (type==SA("int"))
   {
     docs+=SA("<br/>");
-    docs+=SA("Minimum value: ")+child.attribute(SA("minval"))+SA(", ");
-    docs+=SA("maximum value: ")+child.attribute(SA("maxval"))+SA(", ");
-    docs+=SA("default value: ")+child.attribute(SA("defval"))+SA(".");
-    docs+= SA("<br/>");
+    docs+=Expert::tr("Minimum value: %1, maximum value: %2, default value: %3")
+       .arg(child.attribute(SA("minval")))
+       .arg(child.attribute(SA("maxval")))
+       .arg(child.attribute(SA("defval")));
+    docs+=SA("<br/>");
   }
   else if (type==SA("bool"))
   {
     docs+=SA("<br/>");
     if (child.hasAttribute(SA("altdefval")))
     {
-      docs+=SA(" The default value is: system dependent.");
+      docs+=Expert::tr(" The default value is: system dependent.");
     }
     else
     {
       QString defval = child.attribute(SA("defval"));
-      docs+=SA(" The default value is: <code>")+
-            (defval==SA("1")?SA("YES"):SA("NO"))+
-            SA("</code>.");
+      docs+=Expert::tr(" The default value is: <code>%1</code>.").arg((defval==SA("1")?SA("YES"):SA("NO")));
     }
     docs+= SA("<br/>");
   }
@@ -263,19 +251,19 @@ static QString getDocsForNode(const QDomElement &child)
               QString desc = docsVal.attribute(SA("desc"));
               if (desc != SA(""))
               {
-                docs += SA(" ") + desc;
+                docs += Expert::tr(" %1", "for documented list").arg(desc);
               }
               if (i==numValues-1)
               {
-                docs += SA(" and ");
+                docs += Expert::tr(" and ", "for documented list");
               }
               else if (i==numValues)
               {
-                docs += SA(".");
+                docs += Expert::tr(".", "for documented list");
               }
               else
               {
-                docs += SA(", ");
+                docs += Expert::tr(", ", "for documented list");
               }
             }
           }
@@ -293,7 +281,7 @@ static QString getDocsForNode(const QDomElement &child)
       if (defval != SA(""))
       {
         docs+=SA("<br/>");
-        docs += SA(" The default directory is: <code>") + defval + SA("</code>.");
+        docs += Expert::tr(" The default directory is: <code>%1</code>.").arg(defval);
         docs += SA("<br/>");
       }
     }
@@ -305,11 +293,11 @@ static QString getDocsForNode(const QDomElement &child)
         docs+=SA("<br/>");
         if (abspath != SA("1"))
         {
-          docs += SA(" The default file is: <code>") + defval + SA("</code>.");
+          docs += Expert::tr(" The default file is: <code>%1</code>.").arg(defval);
         }
         else
         {
-          docs += SA(" The default file (with absolute path) is: <code>") + defval + SA("</code>.");
+          docs += Expert::tr(" The default file (with absolute path) is: <code>%1</code>.").arg(defval);
         }
         docs += SA("<br/>");
       }
@@ -318,7 +306,7 @@ static QString getDocsForNode(const QDomElement &child)
         if (abspath == SA("1"))
         {
           docs+=SA("<br/>");
-          docs += SA(" The file has to be specified with full path.");
+          docs += Expert::tr(" The file has to be specified with full path.");
           docs += SA("<br/>");
         }
       }
@@ -328,8 +316,8 @@ static QString getDocsForNode(const QDomElement &child)
       if (defval != SA(""))
       {
         docs+=SA("<br/>");
-        docs += SA(" The default value is: <code>") + defval + SA("</code>.");
-        docs += SA("<br/>");
+        docs+=Expert::tr(" The default value is: <code>%1</code>.").arg(defval);
+        docs+=SA("<br/>");
       }
     }
   }
@@ -338,22 +326,24 @@ static QString getDocsForNode(const QDomElement &child)
   {
     QString dependsOn = child.attribute(SA("depends"));
     docs+=SA("<br/>");
-    docs+=  SA(" This tag requires that the tag \\ref cfg_");
-    docs+=  dependsOn.toLower();
-    docs+=  SA(" \"");
-    docs+=  dependsOn.toUpper();
-    docs+=  SA("\" is set to <code>YES</code>.");
+    docs+=Expert::tr(" This tag requires that the tag \\ref cfg_%1 \"%2\" is set to <code>YES</code>.")
+          .arg(dependsOn.toLower())
+          .arg(dependsOn.toUpper());
   }
 
+  return docs;
+}
+
+static QString replaceDoxygenMarkUpToHtml(QString docs)
+{
   // Remove / replace doxygen markup strings
   // the regular expressions are hard to read so the intention will be given
   QRegExp regexp;
-  // remove \n at end and replace by a space
-  regexp.setPattern(SA("\\n$"));
-  docs.replace(regexp,SA(" "));
-  // remove <br> at end
-  regexp.setPattern(SA("<br> *$"));
-  docs.replace(regexp,SA(" "));
+  
+  // replace \n to <br/>, because QTextBrowser treats \n as white-space.
+  regexp.setPattern(SA("\\n"));
+  docs.replace(regexp,SA("<br/>"));
+
   // \c word -> <code>word</code>; word ends with ')', ',', '.' or ' '
   regexp.setPattern(SA("\\\\c[ ]+([^ \\)]+)\\)"));
   docs.replace(regexp,SA("<code>\\1</code>)"));
@@ -371,7 +361,7 @@ static QString getDocsForNode(const QDomElement &child)
   regexp.setPattern(SA("`([^`]+)`"));
   docs.replace(regexp,SA("<code>\\1</code>"));
   // \ref key "desc" -> <code>desc</code>
-  regexp.setPattern(SA("\\\\ref[ ]+[^ ]+[ ]+\"([^ ]+)\""));
+  regexp.setPattern(SA("\\\\ref[ ]+[^ ]+[ ]+\"([^\"]+)\""));
   docs.replace(regexp,SA("<code>\\1</code> "));
   //\ref specials
   // \ref <key> -> description
@@ -383,10 +373,10 @@ static QString getDocsForNode(const QDomElement &child)
   docs.replace(regexp,SA("\"Linking to external documentation\""));
   // fallback for not handled
   docs.replace(SA("\\\\ref"),SA(""));
-  // \b word -> <b>word<\b>
+  // \b word -> <b>word</b>
   regexp.setPattern(SA("\\\\b[ ]+([^ ]+) "));
   docs.replace(regexp,SA("<b>\\1</b> "));
-  // \e word -> <em>word<\em>
+  // \e word -> <em>word</em>
   regexp.setPattern(SA("\\\\e[ ]+([^ ]+) "));
   docs.replace(regexp,SA("<em>\\1</em> "));
   // \note -> <br>Note:
@@ -421,8 +411,8 @@ static QString getDocsForNode(const QDomElement &child)
   // \> -> &gt;
   docs.replace(SA("\\<"),SA("&lt;"));
   docs.replace(SA("\\>"),SA("&gt;"));
-  regexp.setPattern(SA(" (http:[^ \\)]*)([ \\)])"));
-  docs.replace(regexp,SA(" <a href=\"\\1\">\\1</a>\\2"));
+  regexp.setPattern(SA("\\b(http:[^\\s\\)]+)"));
+  docs.replace(regexp,SA("<a href=\"\\1\">\\1</a>"));
   // LaTeX name as formula -> LaTeX
   regexp.setPattern(SA("\\\\f\\$\\\\mbox\\{\\\\LaTeX\\}\\\\f\\$"));
   docs.replace(regexp,SA("LaTeX"));
@@ -447,19 +437,22 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
     QString setting = child.attribute(SA("setting"));
     if (setting.isEmpty() || IS_SUPPORTED(setting.toAscii()))
     {
+      const QString theId = child.attribute(SA("id"));
+      QString docs = translatedTemplateDocs.value(theId) + SA("<br/>");
       QString type = child.attribute(SA("type"));
-      QString docs = getDocsForNode(child);
+      docs += getDocsForNode(child);
+      docs = replaceDoxygenMarkUpToHtml(docs);
       if (type==SA("bool"))
       {
         InputBool *boolOption = 
           new InputBool(
               layout,row,
-              child.attribute(SA("id")),
+              theId,
               child.attribute(SA("defval"))==SA("1"),
               docs
               );
         m_options.insert(
-            child.attribute(SA("id")),
+            theId,
             boolOption
             );
         connect(boolOption,SIGNAL(showHelp(Input*)),SLOT(showHelp(Input*)));
@@ -484,14 +477,14 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
         InputString *stringOption = 
           new InputString(
               layout,row,
-              child.attribute(SA("id")),
+              theId,
               child.attribute(SA("defval")),
               mode,
               docs,
               child.attribute(SA("abspath"))
               );
         m_options.insert(
-            child.attribute(SA("id")),
+            theId,
             stringOption
             );
         connect(stringOption,SIGNAL(showHelp(Input*)),SLOT(showHelp(Input*)));
@@ -501,7 +494,7 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
       {
         InputString *enumList = new InputString(
             layout,row,
-            child.attribute(SA("id")),
+            theId,
             child.attribute(SA("defval")),
             InputString::StringFixed,
             docs
@@ -517,7 +510,7 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
         }
         enumList->setDefault();
 
-        m_options.insert(child.attribute(SA("id")),enumList);
+        m_options.insert(theId,enumList);
         connect(enumList,SIGNAL(showHelp(Input*)),SLOT(showHelp(Input*)));
         connect(enumList,SIGNAL(changed()),SIGNAL(changed()));
       }
@@ -526,14 +519,14 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
         InputInt *intOption = 
           new InputInt(
               layout,row,
-              child.attribute(SA("id")),
+              theId,
               child.attribute(SA("defval")).toInt(),
               child.attribute(SA("minval")).toInt(),
               child.attribute(SA("maxval")).toInt(),
               docs
               );
         m_options.insert(
-            child.attribute(SA("id")),
+            theId,
             intOption
             );
         connect(intOption,SIGNAL(showHelp(Input*)),SLOT(showHelp(Input*)));
@@ -572,13 +565,13 @@ QWidget *Expert::createTopicWidget(QDomElement &elem)
         InputStrList *listOption = 
           new InputStrList(
               layout,row,
-              child.attribute(SA("id")),
+              theId,
               sl,
               mode,
               docs
               );
         m_options.insert(
-            child.attribute(SA("id")),
+            theId,
             listOption
             );
         connect(listOption,SIGNAL(showHelp(Input*)),SLOT(showHelp(Input*)));
@@ -744,7 +737,7 @@ bool Expert::writeConfig(QTextStream &t,bool brief)
   }
 
   QTextCodec *codec = 0;
-  Input *option = m_options[QString::fromAscii("DOXYFILE_ENCODING")];
+  Input *option = m_options[SA("DOXYFILE_ENCODING")];
   if (option)
   {
     codec = QTextCodec::codecForName(option->value().toString().toAscii());
@@ -781,12 +774,12 @@ void Expert::showHelp(Input *option)
   {
     m_inShowHelp = TRUE;
     m_helper->setText(
-        QString::fromAscii("<qt><b>")+option->id()+
-        QString::fromAscii("</b><br>")+
-        QString::fromAscii("<br/>")+
+        SA("<qt><b>")+option->id()+
+        SA("</b><br>")+
+        SA("<br/>")+
         option->docs().
         replace(QChar::fromAscii('\n'),QChar::fromAscii(' '))+
-        QString::fromAscii("</qt>")
+        SA("</qt>")
         );
     m_inShowHelp = FALSE;
   }
@@ -825,7 +818,7 @@ void Expert::resetToDefaults()
 static bool stringVariantToBool(const QVariant &v)
 {
   QString s = v.toString().toLower();
-  return s==QString::fromAscii("yes") || s==QString::fromAscii("true") || s==QString::fromAscii("1");
+  return s==SA("yes") || s==SA("true") || s==SA("1");
 } 
 
 static bool getBoolOption(
@@ -847,7 +840,7 @@ static QString getStringOption(
 
 bool Expert::htmlOutputPresent(const QString &workingDir) const
 {
-  bool generateHtml = getBoolOption(m_options,QString::fromAscii("GENERATE_HTML"));
+  bool generateHtml = getBoolOption(m_options,SA("GENERATE_HTML"));
   if (!generateHtml || workingDir.isEmpty()) return false;
   QString indexFile = getHtmlOutputIndex(workingDir);
   QFileInfo fi(indexFile);
@@ -856,8 +849,8 @@ bool Expert::htmlOutputPresent(const QString &workingDir) const
 
 QString Expert::getHtmlOutputIndex(const QString &workingDir) const
 {
-  QString outputDir = getStringOption(m_options,QString::fromAscii("OUTPUT_DIRECTORY"));
-  QString htmlOutputDir = getStringOption(m_options,QString::fromAscii("HTML_OUTPUT"));
+  QString outputDir = getStringOption(m_options,SA("OUTPUT_DIRECTORY"));
+  QString htmlOutputDir = getStringOption(m_options,SA("HTML_OUTPUT"));
   //printf("outputDir=%s\n",qPrintable(outputDir));
   //printf("htmlOutputDir=%s\n",qPrintable(htmlOutputDir));
   QString indexFile = workingDir;
@@ -867,7 +860,7 @@ QString Expert::getHtmlOutputIndex(const QString &workingDir) const
   }
   else // append
   { 
-    indexFile += QString::fromAscii("/")+outputDir;
+    indexFile += SA("/")+outputDir;
   }
   if (QFileInfo(htmlOutputDir).isAbsolute()) // override
   {
@@ -875,27 +868,27 @@ QString Expert::getHtmlOutputIndex(const QString &workingDir) const
   }
   else // append
   {
-    indexFile += QString::fromAscii("/")+htmlOutputDir;
+    indexFile += SA("/")+htmlOutputDir;
   }
-  indexFile+=QString::fromAscii("/index.html");
+  indexFile+=SA("/index.html");
   return indexFile;
 }
 
 bool Expert::pdfOutputPresent(const QString &workingDir) const
 {
-  bool generateLatex = getBoolOption(m_options,QString::fromAscii("GENERATE_LATEX"));
-  bool pdfLatex = getBoolOption(m_options,QString::fromAscii("USE_PDFLATEX"));
+  bool generateLatex = getBoolOption(m_options,SA("GENERATE_LATEX"));
+  bool pdfLatex = getBoolOption(m_options,SA("USE_PDFLATEX"));
   if (!generateLatex || !pdfLatex) return false;
-  QString latexOutput = getStringOption(m_options,QString::fromAscii("LATEX_OUTPUT"));
+  QString latexOutput = getStringOption(m_options,SA("LATEX_OUTPUT"));
   QString indexFile;
   if (QFileInfo(latexOutput).isAbsolute())
   {
-    indexFile = latexOutput+QString::fromAscii("/refman.pdf");
+    indexFile = latexOutput+SA("/refman.pdf");
   }
   else
   {
-    indexFile = workingDir+QString::fromAscii("/")+
-                latexOutput+QString::fromAscii("/refman.pdf");
+    indexFile = workingDir+SA("/")+
+                latexOutput+SA("/refman.pdf");
   }
   QFileInfo fi(indexFile);
   return fi.exists() && fi.isFile();
diff --git a/addon/doxywizard/for_lupdate_doxywizard.pro.in b/addon/doxywizard/for_lupdate_doxywizard.pro.in
new file mode 100644
index 0000000..5a1ecec
--- /dev/null
+++ b/addon/doxywizard/for_lupdate_doxywizard.pro.in
@@ -0,0 +1,5 @@
+# This project file used only as the parameter of 'lupdate' command.
+# The 'lupdate' command don't search configdoc.cpp through doxywizard.pro.
+
+include(doxywizard.pro)
+SOURCES *= configdoc.cpp
diff --git a/addon/doxywizard/wizard.cpp b/addon/doxywizard/wizard.cpp
index ce989e7..f13a7c2 100644
--- a/addon/doxywizard/wizard.cpp
+++ b/addon/doxywizard/wizard.cpp
@@ -1193,7 +1193,7 @@ Wizard::Wizard(const QHash<QString,Input*> &modelData, QWidget *parent) :
 {
   m_treeWidget = new QTreeWidget;
   m_treeWidget->setColumnCount(1);
-  m_treeWidget->setHeaderLabels(QStringList() << QString::fromAscii("Topics"));
+  m_treeWidget->setHeaderLabels(QStringList() << tr("Topics"));
   QList<QTreeWidgetItem*> items;
   items.append(new QTreeWidgetItem((QTreeWidget*)0,QStringList(tr("Project"))));
   items.append(new QTreeWidgetItem((QTreeWidget*)0,QStringList(tr("Mode"))));
diff --git a/src/configgen.py b/src/configgen.py
index 4aed8bf..1e8937e 100755
--- a/src/configgen.py
+++ b/src/configgen.py
@@ -133,6 +133,19 @@ def parseHeader(node,objName):
 			print "              \"%s\"" % (line)
 	print "             );"
 
+def pickTemplateDocument(node):
+        doc = ""
+        type = node.getAttribute('type')
+        if type == 'obsolete':
+                return doc
+        for n in node.childNodes:
+                if n.nodeName != 'docs' \
+                or n.getAttribute('doxyfile') == '0' \
+                or n.nodeType != Node.ELEMENT_NODE:
+                        continue
+                doc += parseDocs(n)
+        return transformDocs(doc)
+                
 
 def prepCDocs(node):
 	type = node.getAttribute('type')
@@ -356,6 +369,25 @@ def parseGroupCDocs(node):
 						print "              \"%s\"" % (line)
 				print "          );"
 
+def appendInsertingFunction(node):
+	for n in node.childNodes:
+		if n.nodeType == Node.ELEMENT_NODE:
+			type = n.getAttribute('type')
+			if type != 'obsolete':
+				name = n.getAttribute('id')
+				docC = pickTemplateDocument(n)
+				print "  map->insert(SA(\"%s\"), tr(" % (name)
+				rng = len(docC)
+				for i in range(rng):
+					line = docC[i]
+					if i != rng - 1:  # since we go from 0 to rng-1
+						# If you want to fix here, don't forget to
+						# notice translators of doxy"wizard".
+						print "              \"%s\\n\"" % (line)
+					else:
+						print "              \"%s\"" % (line)
+				print "              ));"
+
 def parseOptionDoc(node, first):
 	# Handling part for documentation
 	name = node.getAttribute('id')
@@ -602,6 +634,9 @@ def main():
 		print " */"
 		print "#include \"configdoc.h\""
 		print "#include \"docintf.h\""
+		print "#include <QCoreApplication>"
+		print "#include <qmap.h>"
+		print "#include <qstring.h>"
 		print ""
 		print "void addConfigDocs(DocIntf *doc)"
 		print "{"
@@ -614,6 +649,28 @@ def main():
 				if (n.nodeName == "group"):
 					parseGroupCDocs(n)
 		print "}"
+		print ""
+		print "class ConfigDoc"
+		print "{"
+		print "  Q_DECLARE_TR_FUNCTIONS(ConfigDoc)"
+		print "public:"
+		print "  void addConfigDocs(QMap<QString, QString>* map);"
+		print "  QString SA(const char *s) { return QString::fromAscii(s); }"
+		print "};"
+		print ""
+		print "void addConfigDocs(QMap<QString, QString>* map)"
+		print "{"
+		print "  ConfigDoc().addConfigDocs(map);"
+		print "}"
+		print ""
+		print "void ConfigDoc::addConfigDocs(QMap<QString, QString>* map)"
+		print "{"
+		for n in elem.childNodes:
+			if n.nodeType == Node.ELEMENT_NODE:
+				if (n.nodeName == "group"):
+					appendInsertingFunction(n)
+		print "}"
+		print ""
 
 if __name__ == '__main__':
 	main()
